Subject: bug#55149: 29.0.50; Commit f30625943e broke magit/with-editor

From: "M. Ian Graham" <[email-masked]>
Date: Thu, 28 Apr 2022 04:06:49 +0000

> With stock-emacs when doing "emacsclient foo.txt", it just prints "Waiting for Emacs..." but finishes immediately.

Hi, quick clarification on this: As far as I can tell from my own observations, all emacsclient breakage here is a downstream side-effect of magit/with-editor's advice calls somehow getting messed up.

Observed breakage:

Using bc9be5449e1127bc1b05a6cad8471c6eba52c8e9 and prior I cannot reproduce any related problems. Magit works properly.
Using f30625943edefbd88ebf84acbc254ed88db27beb and later causes the magit-commit command to break with a GitError ("problem with the editor", where the editor is emacsclient) before displaying its message editor window. Given the commit contents I assume the advice-add usage in with-editor is being affected somehow.

emacsclient issues:

In the same emacs instance as above, only after first reproducing the magit-commit error (and presumably leaving a stalled client connection in place), later emacsclient usage fails via the CLI.
Given a new session using a fresh server-start and using basic emacsclient commands, I don't observe any problems.

If I'm misunderstanding anyone and you're able to repro manual emacsclient breakage with a fresh server, please follow up.

I'm not yet sure what a minimal breaking advice test looks like. Trying simple advice-add calls that look similar to with-editor's hasn't turned up any problems yet. I'll shout back if I find something.
-Ian